/*-------------------------------------------------------------------------


	An exit function for SICS.
	


	Mark Koennecke,    November 1996

	Copyright:

	Labor fuer Neutronenstreuung
	Paul Scherrer Institut
	CH-5423 Villigen-PSI


        The authors hereby grant permission to use, copy, modify, distribute,
        and license this software and its documentation for any purpose, provided
        that existing copyright notices are retained in all copies and that this
        notice is included verbatim in any distributions. No written agreement,
        license, or royalty fee is required for any of the authorized uses.
        Modifications to this software may be copyrighted by their authors
        and need not follow the licensing terms described here, provided that
        the new terms are clearly indicated on the first page of each file where
        they apply.

        IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
        FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
        ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
        DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
        POSSIBILITY OF SUCH DAMAGE.

        THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
        INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
        FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
        IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
        NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
        MODIFICATIONS.
	
-----------------------------------------------------------------------------*/

#include "fortify.h"
#include <stdlib.h>
#include <assert.h>
#include "task.h"
#include "nserver.h"
#include "sicsexit.h"
/*----------------------------------------------------------------------
   Below waits for 5 cycles in order to give everybody time to shut down
   properly. Then this one will die as well
*/   
  static int WaitTask(void *pData)
  {
     static int iCount = 0; 

     iCount++;
     if(iCount > 4)
     {
       return 0;
     }      
     return 1;
  }

/*-------------------------------------------------------------------------*/

 int SicsExit(SConnection *pCon, SicsInterp *pInterp, void *pData,
              int argc, char *argv[])
 {
    pTaskMan pTask = NULL;
    long lID;

    assert(pCon);
    assert(pInterp);
    
    pTask = GetTasker();
    assert(pTask);
    
    if(SCMatchRights(pCon,usMugger)) /* only Muggers are allowed to do it*/
    {
      SetInterrupt(eEndServer);
      lID = TaskRegister(pTask,WaitTask,NULL,NULL,NULL,1);
      TaskWait(pTask,lID);
      TaskStop(pTask);
      return 1;
    }
    else
    {
      SCWrite(pCon,"You are not privileged to close the server",eError);
      SCWrite(pCon," Get a Manager to do it",eError);
      return 0;
    }    
 }

